TaskCollection (Gradle API 2.14.1)

org.gradle.api.tasks

## Interface TaskCollection<T extends Task>

- Type Parameters:
    `T` - The type of tasks which this collection contains.
  All Superinterfaces:
    Collection<T>, DomainObjectCollection<T>, Iterable<T>, NamedDomainObjectCollection<T>, NamedDomainObjectSet<T>, Set<T>
  All Known Subinterfaces:
    TaskContainer

      public interface TaskCollection<T extends Task>
      extends NamedDomainObjectSet<T>

  A `TaskCollection` contains a set of `Task` instances, and provides a number of query methods.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `getAt(String name)` Locates an object by name, failing if there is no such task.
    `T` | `getByName(String name)` Locates an object by name, failing if there is no such object.
    `T` | `getByName(String name, Closure configureClosure)` Locates an object by name, failing if there is no such object.
    `TaskCollection<T>` | `matching(Closure closure)` Returns a collection which contains the objects in this collection which meet the given closure specification.
    `TaskCollection<T>` | `matching(Spec<? super T> spec)` Returns a collection which contains the objects in this collection which meet the given specification.
    `Action<? super T>` | `whenTaskAdded(Action<? super T> action)` Adds an `Action` to be executed when a task is added to this collection.
    `void` | `whenTaskAdded(Closure closure)` Adds a closure to be called when a task is added to this collection.
    `<S extends T> TaskCollection<S>` | `withType(Class<S> type)` Returns a collection containing the objects in this collection of the given type.

    - ### Methods inherited from interface org.gradle.api.NamedDomainObjectSet

      `findAll`

    - ### Methods inherited from interface org.gradle.api.NamedDomainObjectCollection

      `add, addAll, addRule, addRule, findByName, getAsMap, getNamer, getNames, getRules`

    - ### Methods inherited from interface org.gradle.api.DomainObjectCollection

      `all, all, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType`

    - ### Methods inherited from interface java.util.Collection

      `clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Method Detail

    - #### matching

          TaskCollection<T> matching(Spec<? super T> spec)

      Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T extends Task>`
      Specified by:
        `matching` in interface `NamedDomainObjectCollection<T extends Task>`
      Specified by:
        `matching` in interface `NamedDomainObjectSet<T extends Task>`
      Parameters:
        `spec` - The specification to use.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### matching

          TaskCollection<T> matching(Closure closure)

      Returns a collection which contains the objects in this collection which meet the given closure specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T extends Task>`
      Specified by:
        `matching` in interface `NamedDomainObjectCollection<T extends Task>`
      Specified by:
        `matching` in interface `NamedDomainObjectSet<T extends Task>`
      Parameters:
        `closure` - The specification to use. The closure gets a collection element as an argument.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### getByName

          T getByName(String name,
                    Closure configureClosure)
                                   throws UnknownTaskException

      Locates an object by name, failing if there is no such object. The given configure closure is executed against the object before it is returned from this method. The object is passed to the closure as its delegate.
      Specified by:
        `getByName` in interface `NamedDomainObjectCollection<T extends Task>`
      Parameters:
        `name` - The object name
        `configureClosure` - The closure to use to configure the object.
      Returns:
        The object with the given name, after the configure closure has been applied to it. Never returns null.
      Throws:
        `UnknownTaskException`

    - #### getByName

          T getByName(String name)
                                   throws UnknownTaskException

      Locates an object by name, failing if there is no such object.
      Specified by:
        `getByName` in interface `NamedDomainObjectCollection<T extends Task>`
      Parameters:
        `name` - The object name
      Returns:
        The object with the given name. Never returns null.
      Throws:
        `UnknownTaskException`

    - #### withType

          <S extends T> TaskCollection<S> withType(Class<S> type)

      Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.
      Specified by:
        `withType` in interface `DomainObjectCollection<T extends Task>`
      Specified by:
        `withType` in interface `NamedDomainObjectCollection<T extends Task>`
      Specified by:
        `withType` in interface `NamedDomainObjectSet<T extends Task>`
      Parameters:
        `type` - The type of objects to find.
      Returns:
        The matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### whenTaskAdded

          Action<? super T> whenTaskAdded(Action<? super T> action)

      Adds an `Action` to be executed when a task is added to this collection.
      Parameters:
        `action` - The action to be executed
      Returns:
        the supplied action

    - #### whenTaskAdded

          void whenTaskAdded(Closure closure)

      Adds a closure to be called when a task is added to this collection. The task is passed to the closure as the parameter.
      Parameters:
        `closure` - The closure to be called

    - #### getAt

          T getAt(String name)
                               throws UnknownTaskException

      Locates an object by name, failing if there is no such task. This method is identical to `NamedDomainObjectCollection.getByName(String)`. You can call this method in your build script by using the groovy `[]` operator.
      Specified by:
        `getAt` in interface `NamedDomainObjectCollection<T extends Task>`
      Parameters:
        `name` - The object name
      Returns:
        The object with the given name. Never returns null.
      Throws:
        `UnknownTaskException`